Package org.optaplanner.core.impl.heuristic.selector.value.mimic

## Class MimicReplayingValueSelector<Solution_>

- java.lang.Object
- - org.optaplanner.core.impl.heuristic.selector.AbstractSelector<Solution_>
  - - org.optaplanner.core.impl.heuristic.selector.value.AbstractValueSelector<Solution_>
    - - org.optaplanner.core.impl.heuristic.selector.value.mimic.MimicReplayingValueSelector<Solution_>

- All Implemented Interfaces:
    `Iterable<Object>`, `EventListener`, `IterableSelector<Solution_,​Object>`, `Selector<Solution_>`, `EntityIndependentValueSelector<Solution_>`, `ValueSelector<Solution_>`, `PhaseLifecycleListener<Solution_>`, `SolverLifecycleListener<Solution_>`

      public class MimicReplayingValueSelector<Solution_>
      extends AbstractValueSelector<Solution_>
      implements EntityIndependentValueSelector<Solution_>

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected boolean` | `hasRecording` |
    `protected boolean` | `hasRecordingCreated` |
    `protected Object` | `recording` |
    `protected boolean` | `recordingAlreadyReturned` |
    `protected boolean` | `recordingCreated` |
    `protected ValueMimicRecorder<Solution_>` | `valueMimicRecorder` |

    - ### Fields inherited from class org.optaplanner.core.impl.heuristic.selector.AbstractSelector

      `logger, phaseLifecycleSupport, workingRandom`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `MimicReplayingValueSelector​(ValueMimicRecorder<Solution_> valueMimicRecorder)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `Iterator<Object>` | `endingIterator​(Object entity)` | If `Selector.isNeverEnding()` is true, then `ValueSelector.iterator(Object)` will never end.
    `long` | `getSize()` | A random JIT `Selector` with `Selector.isNeverEnding()` true should return a size as if it would be able to return each distinct element only once, because the size can be used in `SelectionProbabilityWeightFactory`.
    `long` | `getSize​(Object entity)` | Similar to `IterableSelector.getSize()`, but requires an entity.
    `GenuineVariableDescriptor<Solution_>` | `getVariableDescriptor()` |
    `boolean` | `isCountable()` | If false, then `Selector.isNeverEnding()` is true.
    `boolean` | `isNeverEnding()` | Is true if `Selector.isCountable()` is false or if this selector is in random order (for most cases).
    `Iterator<Object>` | `iterator()` |
    `Iterator<Object>` | `iterator​(Object entity)` | Similar to `Iterable.iterator()`, but requires an entity.
    `void` | `phaseEnded​(AbstractPhaseScope<Solution_> phaseScope)` |
    `void` | `phaseStarted​(AbstractPhaseScope<Solution_> phaseScope)` |
    `void` | `recordedHasNext​(boolean hasNext)` |
    `void` | `recordedNext​(Object next)` |
    `String` | `toString()` |

    - ### Methods inherited from class org.optaplanner.core.impl.heuristic.selector.AbstractSelector

      `getCacheType, solvingEnded, solvingStarted, stepEnded, stepStarted`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.lang.Iterable

      `forEach`

    - ### Methods inherited from interface org.optaplanner.core.impl.heuristic.selector.IterableSelector

      `spliterator`

    - ### Methods inherited from interface org.optaplanner.core.impl.phase.event.PhaseLifecycleListener

      `stepEnded, stepStarted`

    - ### Methods inherited from interface org.optaplanner.core.impl.heuristic.selector.Selector

      `getCacheType`

    - ### Methods inherited from interface org.optaplanner.core.impl.solver.event.SolverLifecycleListener

      `solvingEnded, solvingStarted`

- - ### Field Detail

    - #### valueMimicRecorder

          protected final ValueMimicRecorder<Solution_> valueMimicRecorder

    - #### hasRecordingCreated

          protected boolean hasRecordingCreated

    - #### hasRecording

          protected boolean hasRecording

    - #### recordingCreated

          protected boolean recordingCreated

    - #### recording

          protected Object recording

    - #### recordingAlreadyReturned

          protected boolean recordingAlreadyReturned

  - ### Constructor Detail

    - #### MimicReplayingValueSelector

          public MimicReplayingValueSelector​(ValueMimicRecorder<Solution_> valueMimicRecorder)

  - ### Method Detail

    - #### phaseStarted

          public void phaseStarted​(AbstractPhaseScope<Solution_> phaseScope)

      Specified by:
        `phaseStarted` in interface `PhaseLifecycleListener<Solution_>`
      Overrides:
        `phaseStarted` in class `AbstractSelector<Solution_>`

    - #### phaseEnded

          public void phaseEnded​(AbstractPhaseScope<Solution_> phaseScope)

      Specified by:
        `phaseEnded` in interface `PhaseLifecycleListener<Solution_>`
      Overrides:
        `phaseEnded` in class `AbstractSelector<Solution_>`

    - #### getVariableDescriptor

          public GenuineVariableDescriptor<Solution_> getVariableDescriptor()

      Specified by:
        `getVariableDescriptor` in interface `ValueSelector<Solution_>`
      Returns:
        never null

    - #### isCountable

          public boolean isCountable()

      Description copied from interface: `Selector`
      If false, then `Selector.isNeverEnding()` is true.
      Specified by:
        `isCountable` in interface `Selector<Solution_>`
      Returns:
        true if all the `ValueRange`s are countable (for example a double value range between 1.2 and 1.4 is not countable)

    - #### isNeverEnding

          public boolean isNeverEnding()

      Description copied from interface: `Selector`
      Is true if `Selector.isCountable()` is false or if this selector is in random order (for most cases). Is never true when this selector is in shuffled order (which is less scalable but more exact).
      Specified by:
        `isNeverEnding` in interface `Selector<Solution_>`
      Returns:
        true if the `Iterator.hasNext()` of the `Iterator` created by `Iterable.iterator()` never returns false (except when it's empty).

    - #### getSize

          public long getSize​(Object entity)

      Description copied from interface: `ValueSelector`
      Similar to `IterableSelector.getSize()`, but requires an entity.
      Specified by:
        `getSize` in interface `ValueSelector<Solution_>`
      Parameters:
        `entity` - never null
      Returns:
        the approximate number of elements generated by this `Selector`, always `>= 0`

    - #### getSize

          public long getSize()

      Description copied from interface: `IterableSelector`
      A random JIT `Selector` with `Selector.isNeverEnding()` true should return a size as if it would be able to return each distinct element only once, because the size can be used in `SelectionProbabilityWeightFactory`.
      Specified by:
        `getSize` in interface `IterableSelector<Solution_,​Object>`
      Returns:
        the approximate number of elements generated by this `Selector`, always `>= 0`

    - #### iterator

          public Iterator<Object> iterator​(Object entity)

      Description copied from interface: `ValueSelector`
      Similar to `Iterable.iterator()`, but requires an entity.
      Specified by:
        `iterator` in interface `ValueSelector<Solution_>`
      Parameters:
        `entity` - never null
      Returns:
        never null

    - #### iterator

          public Iterator<Object> iterator()

      Specified by:
        `iterator` in interface `Iterable<Solution_>`

    - #### recordedHasNext

          public void recordedHasNext​(boolean hasNext)

    - #### recordedNext

          public void recordedNext​(Object next)

    - #### endingIterator

          public Iterator<Object> endingIterator​(Object entity)

      Description copied from interface: `ValueSelector`
      If `Selector.isNeverEnding()` is true, then `ValueSelector.iterator(Object)` will never end. This returns an ending `Iterator`, that tries to match `ValueSelector.iterator(Object)` as much as possible, but return each distinct element only once and therefore it might not respect the configuration of this `ValueSelector` entirely.
      Specified by:
        `endingIterator` in interface `ValueSelector<Solution_>`
      Parameters:
        `entity` - never null
      Returns:
        never null
      See Also:
        `ValueSelector.iterator(Object)`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`